]> git.phdru.name Git - dotfiles.git/blob - .shellrc
.shellrc: remove clo aliases - clear is called in .logout
[dotfiles.git] / .shellrc
1 #
2 # $HOME/.shellrc
3 #
4
5 # ~/.bashrc: executed by bash(1) for non-login shells.
6 # see /usr/share/doc/bash/examples/startup-files (in the package bash-doc)
7 # for examples
8
9 # If not running interactively, don't do anything
10 case $- in
11     *i*) ;;
12       *) return;;
13 esac
14
15 # Stop if non-interactive shell
16 # [ -z "$PS1" ] && return
17
18 if test -n "$BASH_VERSION"; then
19    # append to the history file, don't overwrite it
20    shopt -s histappend
21
22    # check the window size after each command and, if necessary,
23    # update the values of LINES and COLUMNS.
24    shopt -s checkwinsize
25
26    # If set, the pattern "**" used in a pathname expansion context will
27    # match all files and zero or more directories and subdirectories.
28    #shopt -s globstar
29 fi
30
31
32 #if [ -x /usr/bin/dircolors ]; then
33 #   # I don't like these aliases - they work only in command line
34 #   # but not in scripts I run from command line.
35 #   # Color parameters must be passed via environment.
36 #   # So instead I put them in shell scripts in ~/bin.
37 #   alias ls='ls --color=auto'
38 #   alias dir='dir --color=auto'
39 #   alias vdir='vdir --color=auto'
40 #
41 #   alias grep='grep --color=auto'
42 #   alias fgrep='fgrep --color=auto'
43 #   alias egrep='egrep --color=auto'
44 #
45 #   alias dmesg='dmesg --human'
46 #fi
47
48
49 case "$HOME" in
50    /home/*)
51       if [ -L /home ]; then
52          START_DIR="`pwd`" &&
53          cd "$HOME" &&
54          HOME="`pwd`" &&
55          cd "$START_DIR"
56       fi
57    ;;
58 esac
59
60
61 OPS1="$OPS1\\$"
62 PS1="$OPS1 "
63
64
65 if test -n "$BASH_VERSION"; then
66    [ "`type -t ls`" = alias ] && unalias ls
67    [ "`type -t ll`" = alias ] && unalias ll
68    [ "`type -t mc`" = alias ] && unalias mc
69
70    back() { cd - "$@"; }
71    functions() { typeset -f "$@"; }
72    j() { jobs; }
73
74    if [ -z "$BASH_COMPLETION_COMPAT_DIR" ]; then
75       if [ "$SHELL" = /bin/bash ]; then
76          if [ -f /etc/bash_completion ]; then
77             . /etc/bash_completion
78          elif [ -d /etc/bash_completion.d ]; then
79             . /etc/bash_completion.d/*
80          fi
81       elif [ "$SHELL" = /usr/local/bin/bash ]; then
82          if [ -d /usr/local/etc/bash_completion.d ]; then
83             . /usr/local/etc/bash_completion.d/*
84          fi
85       else
86          echo "Unknown OS type, canot source bash_completion" >&2
87       fi
88    fi
89
90    has_completion() { return 0; }
91    if [ "$SHELL" = /bin/bash ]; then
92       if [ -d /etc/bash_completion.d -o -d /usr/share/bash-completion/completions ]; then
93          has_completion() { [ -r /etc/bash_completion.d/$1 -o -r /usr/share/bash-completion/completions/$1 ]; }
94       fi
95    elif [ "$SHELL" = /usr/local/bin/bash ]; then
96       if [ -d /usr/local/etc/bash_completion.d ]; then
97          has_completion() { [ -r /usr/local/etc/bash_completion.d/$1 ]; }
98       fi
99    fi
100
101    for cmd in builtin cgmem_nice command dbus-launch exec \
102       killall man nice nohup pidof pidOf KillAll pgrep pkill psg pswg su sudo \
103       time whence whereis which xargs; do
104          ! has_completion $cmd && complete -o default -A command $cmd
105    done
106
107    for cmd in dig host mtr nslookup nc netcat nmap p ping ping6 socat \
108       telnet t tt \
109       tcptraceroute tcptraceroute6 tracert tracert6 traceroute traceroute6 \
110       whois wget wget-m wget-wrapper ww; do
111          ! has_completion $cmd && complete -A hostname $cmd
112    done
113
114    for cmd in distribute ftp lftp r rsync \
115       s scp ssh smbclient tcpdump tshark wireshark; do
116          ! has_completion $cmd && complete -o default -A hostname $cmd;
117    done
118
119    delegate_completion() {
120       local prog completion_f programs
121       prog="$1"
122       completion_f="$2"
123       shift; shift
124       programs="$@"
125       if has_completion "$prog"; then
126          eval "_${prog}_completion_loader() {
127             _completion_loader $prog
128             complete -F $completion_f $programs
129             unset _${prog}_completion_loader
130             return 124
131          }"
132          complete -F _"$prog"_completion_loader $programs
133       fi
134    }
135
136    delegate_completion make _make m
137    delegate_completion rsync _rsync r
138    delegate_completion ssh _ssh s
139    delegate_completion wget _wget wget-m wget-wrapper ww
140
141    unset has_completion delegate_completion
142
143    complete -A job bg fg j jobs wait
144    complete -A variable -A function unset
145
146    if [ -d "$HOME/lib/config" ]; then
147       complete -W "`cd \"$HOME/lib/config\" && echo *`" include
148    fi
149    complete -W "`echo $BROWSER | sed 's/:/ /g'`" start-browser
150
151    #if type -p pip >/dev/null 2>&1; then
152    #   eval "`pip completion --bash`"
153    #   rm -rf /tmp/pip_build_"$USER"
154    #fi
155
156 elif test -n "$KSH_VERSION" -o -n "$FCEDIT"; then
157    back() { cd - "$@"; }
158    j() { jobs; }
159 fi
160
161
162 # clear history, clear screen and logout
163
164
165 #Pwd() { pwd | sed "s/.*\/\(.*\)\/\(.*\)\/\(.*\)\/\(.*\)/...\/\2\/\3\/\4/"; }
166 #PWd() { pwd | sed "s/.*\/\(.*\)\/\(.*\)/...\/\2/"; }
167
168
169 psg()   { ps auxw   | grep -i "$@" | grep -v '\(ps auxw\|grep\)'; }
170 pswg()  { ps auxwww | grep -i "$@" | grep -v '\(ps auxw\|grep\)'; }
171
172 # Like pgrep -f
173 pidOf() { ps auxwww | grep -i "$@" | grep -v '\(ps auxw\|grep\|pidOf\|KillAll\)' | awk '{print $2}'; }
174
175 # A kind of pkill/killall
176 KillAll() {
177    if [ -z "$1" -o -n "$3" ]; then
178       echo "Usage: KillAll [-signal] proc_regexp" >&2
179       return 1
180    fi
181    if [ -z "$2" ]; then
182       kill `pidOf "$1"`
183    else
184       kill "$1" `pidOf "$2"`
185    fi
186 }
187 #chlo() { cd; unset HISTFILE; rm -f .sh_history; history -c; clear; logout || exit; }
188
189
190 if test -x /usr/bin/git >/dev/null 2>&1; then
191    # chdir to a remote's directory (if the remote is on the local FS)
192    cdremote() {
193       if [ -z "$1" -o -n "$2" ]; then
194          echo "Usage: cdremote remote_name" >&2
195          return 1
196       fi
197       cd "`git config --get remote.$1.url`"
198    }
199
200    if test -n "$BASH_VERSION"; then
201       # completion for global aliases in .gitconfig
202
203       # fixup rbi rbia rbiap rbip - do refs name completion
204       _git_fixup() { __gitcomp_nl "$(__git_refs)" ; }
205       _git_rbi() { __gitcomp_nl "$(__git_refs)" ; }
206       _git_rbia() { __gitcomp_nl "$(__git_refs)" ; }
207       _git_rbiap() { __gitcomp_nl "$(__git_refs)" ; }
208       _git_rbip() { __gitcomp_nl "$(__git_refs)" ; }
209       #
210       # push-to-all-remotes - do branch name completion
211       _git_push_to_all_remotes() { __gitcomp_nl "$(__git_heads)" ; }
212
213       # list remotes with URLs matching a regexp
214       _list_remotes() {
215          if [ -z "$1" -o -n "$2" ]; then
216             echo "Usage: _list_remotes remote_regexp" >&2
217             return 1
218          fi
219          GIT_REMOTES=""
220          local remote
221          for remote in `git remote`; do
222             if git config --get remote.$remote.url | grep -q "$1"; then
223                GIT_REMOTES="$GIT_REMOTES $remote"
224             fi
225          done
226       }
227
228       # completion for cdremote and git-open - list remotes with a pattern
229       _list_remotes_completion() {
230          local cur="${COMP_WORDS[COMP_CWORD]}";
231          _list_remotes "$1"
232          COMPREPLY=(`compgen -W "$GIT_REMOTES" -- "$cur"`)
233          unset GIT_REMOTES
234       }
235
236       # completion for cdremote - list remotes with directories as URLs
237       _cdremote_complete() {
238          _list_remotes_completion '^\(/\|\.\./\)' # (/ or ../ at the beginning)
239       }
240
241       complete -F _cdremote_complete cdremote
242
243       # completion for git-open - list remotes with http(s) URLs
244       _git_open() {
245          _list_remotes_completion '^http\(s\)\?://'
246       }
247
248       complete -F _git_open git-open
249    fi
250 fi
251
252
253 include() {
254    cfg="$1"
255    if [ -f "./$cfg" -a -r "./$cfg" ]; then
256       echo "Reading config file \`$cfg'" 1>&2
257       . "./$cfg"
258    elif [ -f "$HOME/lib/config/$cfg" -a -r "$HOME/lib/config/$cfg" ]; then
259       echo "Reading config file \`$HOME/lib/config/$cfg'" 1>&2
260       . "$HOME/lib/config/$cfg"
261    else
262       echo "Cannot find config file \`$cfg'" 1>&2
263    fi
264 }
265
266
267 mc() {
268    if test -n "$BASH_VERSION"; then
269       MC_SAVE_OPS1="$OPS1"
270       OPS1="\u@\h "
271    fi
272
273    if [ -n "$SLOWTERM" ]; then
274       MC_SLOW="--slow"
275    fi
276
277    case "$TERM" in
278       screen*) # screen, screen.rxvt
279          if [ "$TERM" = screen.rxvt ]; then
280             MC_SAVE_TERM="$TERM"
281             TERM=rxvt
282          fi
283          MC_XTERM="-x"
284       ;;
285    esac
286
287    #TMPDIR="$HOME"/tmp
288    #export TMPDIR
289
290    MC_FOUND=NO
291
292    for wrapper in \
293          /usr/local/share/mc/bin/mc-wrapper.sh \
294          /usr/local/libexec/mc/mc-wrapper.sh \
295          /usr/share/mc/bin/mc-wrapper.sh; do
296       if [ -r $wrapper ]; then
297          . $wrapper $MC_SLOW $MC_XTERM "$@"
298          rc=$?
299          MC_FOUND=YES
300          break
301       fi
302    done
303
304    if [ $MC_FOUND = NO ]; then
305       for mc in /usr/local/bin/mc /usr/bin/mc; do
306          if [ -x $mc ]; then
307             MC_TMP_DIR="${TMPDIR-/tmp}/mc-$USER"
308             if [ ! -d MC_TMP_DIR="${TMPDIR-/tmp}/mc-$USER" ]; then
309                MC_TMP_DIR="${TMPDIR-/tmp}"
310             fi
311             MC_PWD_FILE="$MC_TMP_DIR/mc.pwd.$$"
312             mc_type="`mc_type.py $mc`"
313             if [ "$mc_type" = old ]; then
314                $mc -P $MC_SLOW $MC_XTERM "$@" > "$MC_PWD_FILE"
315             elif [ "$mc_type" = new ]; then
316                $mc -P "$MC_PWD_FILE" $MC_SLOW $MC_XTERM "$@"
317             else
318                continue
319             fi
320             rc=$?
321             MC_FOUND=YES
322             cd "`cat \"$MC_PWD_FILE\"`" && /bin/rm "$MC_PWD_FILE"
323             break
324          fi
325       done
326    fi
327
328    if [ $MC_FOUND = NO ]; then
329       echo "Cannot find mc-wrapper.sh or mc" >&2
330       rc=1
331    fi
332
333    [ -n "$MC_SAVE_OPS1" ] && OPS1="$MC_SAVE_OPS1"
334    [ -n "$MC_SAVE_TERM" ] && TERM="$MC_SAVE_TERM"
335    unset MC_FOUND MC_PWD_FILE MC_SAVE_OPS1 MC_SAVE_TERM \
336          MC_SLOW MC_TMP_DIR MC_XTERM
337
338    return $rc
339 }
340
341
342 mkcd() {
343    if [ $# -ne 1 ]; then
344       echo "Usage: mkcd directory_name" >&2
345    elif [ -d "$1" ]; then
346       cd "$1"
347    elif [ -e "$1" ]; then
348       echo "Error: $1 is a file" >&2
349    else
350       mkdir -p "$1" && cd "$1"
351    fi
352 }
353
354
355 if which tmux >/dev/null 2>&1; then
356    tmux() {
357       case "$TERM" in
358          rxvt)
359             TERM=rxvt-unicode command tmux "$@"
360          ;;
361
362          *)
363             command tmux "$@"
364          ;;
365       esac
366    }
367 fi
368
369
370 #if which pyenv >/dev/null 2>&1; then
371 #   eval "`pyenv init -`"
372 #   eval "`pyenv virtualenv-init -`"
373 #fi
374
375 if [ -f /usr/local/bin/virtualenvwrapper_lazy.sh ]; then
376    source /usr/local/bin/virtualenvwrapper_lazy.sh
377 fi
378
379
380 if [ "$SHLVL" -eq 1 ] && which startx >/dev/null 2>&1; then
381    X() { startx >> .Xserver.log 2>&1; cyr; }
382 fi
383
384 x() { exit; }